<?php
/* agg.inc
 *    EN language include file for the Aggregator
 *
 * 2015-03-23 v2.0.1 Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: EN/agg.inc, v2.0.1 2015-03-23
 * @author Alex KEMP
 * @translator Alex KEMP
 *
 * Note: this file *must* be utf-8 encoded, Unix line-endings for best.
 * Translator note:
 *   Take care: PHP + Bash + Apache code is mixed in below with plain text.
 *   Text can be translated; php/bash/apache must not.
 *   For info: some lines have `xxx' in them;
 *             that becomes the target of a search/replace
 *             reason: php var value postdates inclusion
 */
	// lang arrays: EN English
	$S_CONTENT_DIRECTION['EN']	= 'ltr';	// left-to-right; Arabic, Hebrew, etc. are `rtl' (right-to-left)

	$ENTRY_TIP['EN']				= 'Post IPs in a block of text, or an ASN';
	// do not translate `_URL' in the following line:
	$ERROR_TEXT_ASN['EN']		= "An unknown error occurred whilst getting the page at:<br /><br /><a href='_URL'>_URL</a><br /><br />(there may have been too many ASN pages taken by us from CIDR-report recently)";
	$ERROR_TEXT_EMPTY['EN']		= "This utility can recognise neither bare IPs nor IP/prefixes nor IP ranges within your text entry.";
	$ERROR_TEXT_SIZE['EN']		= "You have attempted to post more than ".
		number_format( $POST_LIMIT / 1024 ) ."k (". number_format( $POST_LIMIT ).
		" bytes) of text (post = xxx".
		" bytes). This utility refuses to process that much text.";
	$ERRTXT_200_01['EN']			= "xxx (bad ip format)\n";
	$ERRTXT_200_02['EN']			= "xxx (bad mask)\n";
	$ERRTXT_200_03['EN']			= "xxx (bad IP or IP/Prefix)\n";
	$ERRTXT_200_04['EN']			= 'IP/Subnet-Masks';
	$ERRTXT_200_05['EN']			= 'IP Ranges';
	$ERRTXT_200_06['EN']			= 'Bad-Neighbour lines';
	$ERRTXT_200_07['EN']			= 'ZB Block sig lines';
	$ERRTXT_200_08['EN']			= '.htaccess Deny lines';
	$ERRTXT_200_09['EN']			= 'CIDR';
	$ERRTXT_200_10['EN']			= ' Ranges, ';
	$ERRTXT_200_11['EN']			= ' Net/Mask + ';
	$ERRTXT_200_12['EN']			= " IPs and/or CIDR supplied\n";
	$ERRTXT_200_13['EN']			= " aggregated xxx from these IPs shown below:\n\n";
	$ERRTXT_200_14['EN']			= "Settings:\n";
	$ERRTXT_200_15['EN']			= "ASN page:\nxxx\n\n";
	$ERRTXT_200_16['EN']			= "Detect:\n  IPv4\n  IPv4/Prefix (CIDR)\n  IPv4/Mask\n  IPv4 Range\n".
		"Output:\n  xxx\n\n".
		"IPs Accepted/Rejected within XXX kB of text:\n";
	$ERRTXT_200_17['EN']			= " Rejected:\n";
	$ERRTXT_200_18['EN']			= " Accepted:\nxxx";
	$ERRTXT_400_1['EN']			= "Error from agg_get(): \$url=xxx";
	$ERRTXT_400_2['EN']			= "No results in \$matches";
	$ERRTXT_403_1['EN']			= "Attempt to post xxx bytes text";
	$L_BAD_KEY['EN']				= 'B';
	$L_BAD_TEXT['EN']				= '<u>B</u>-N';
	$L_BAD_TITLE['EN']			= 'Show output as bash code suitable for building a Bad-Neighbours iptables listing';
	$L_CIDR_KEY['EN']				= 'C';
	$L_CIDR_TEXT['EN']			= '<u>C</u>IDR';
	$L_CIDR_TITLE['EN']			= 'Show output as IP/Prefix; eg 192.168.37.192/27';
	$L_HTA_KEY['EN']				= 'H';
	$L_HTA_TEXT['EN']				= '<u>H</u>TA';
	$L_HTA_TITLE['EN']			= 'Show output as blocking code suitable for an .htaccess (Apache) file';
	$L_MASK_KEY['EN']				= 'M';
	$L_MASK_TEXT['EN']			= '<u>M</u>ask';
	$L_MASK_TITLE['EN']			= 'Show output as IP/Mask; eg 192.168.37.215/255.255.255.224';
	$L_OUTPUT_ASN['EN']			= 'ASN';
	$L_OUTPUT_OUTPUT['EN']		= 'Output';
	$L_OUTPUT_TEXT['EN']			= 'Text';
	$L_POST['EN']					= 'Post Text / AS-Number';
	$L_RANGE_KEY['EN']			= 'R';
	$L_RANGE_TEXT['EN']			= '<u>R</u>ange';
	$L_RANGE_TITLE['EN']			= 'Show output as IP Ranges; eg 192.168.37.192 - 192.168.37.223';
	$L_RESULT['EN']				= 'Results';
	$L_ZBB_KEY['EN']				= 'Z';
	$L_ZBB_TEXT['EN']				= '<u>Z</u>BB';
	$L_ZBB_TITLE['EN']			= 'Show output as blocking code suitable for a ZB-Block config file';
	$PAGE_TITLE['EN']				= 'IP Aggregator';
	$SUBMIT['EN']					= 'Submit';

	// following used on no-post pages
	$RESULTS['EN']					= "This is where the results will appear (max: ". number_format( $POST_LIMIT / 1024 ) ."k text).

Free text: accept:  IPv4
(quick)    and/or   IPv4/Prefix (CIDR)
           and/or   IPv4/Subnet-Mask
           and/or   IPv4 Range

           example: 192.168.37.215
                    192.168.37.215/27
                    192.168.37.215/255.255.255.224
                    192.168.37.192 - 192.168.37.223

           The utility will pick out &amp; aggregate all the IP/CIDR/Mask/Ranges
           from within a block of text pasted into the text-box (max: ". number_format( $POST_LIMIT / 1024 ) ."k).

ASN:       Alternatively, enter an ASN (eg AS5089 or 5089)
(slower)   and the current page from cidr-report.org will be used.
           (ASN entry disabled if the server cannot access remote URLs)

Output:    Choose one of:       Example
                                -------
           CIDR (default)       192.168.37.192/27
           Mask                 192.168.37.215/255.255.255.224
           Range                192.168.37.192 - 192.168.37.223
           Bad-Neighbours       http://forums.modem-help.co.uk/viewtopic.php?t=2015
           .htaccess            (url to be added)
           ZB-Block             http://www.spambotsecurity.com/zbblock.php";

	$BAD_TOP['EN']					= "# $NOW generate a Firewall here:
# http://www.orange-sans-guigne.com/efg/efg.php
#
# Note: as supplied, this cannot be used as a standalone-script

IPT='/sbin/iptables'
# $NOW Create a user-chain to filter packets from bad neighbourhoods
\$IPT -N bad_neighbours

###############################################################################
#
# bad_neighbours chain
#
# All inbound packets traverse this chain.
# It is used to DROP packets from bad neighbourhoods.
# $NOW See also http://forums.modem-help.co.uk/viewtopic.php?t=2015\n\n";

	$BAD_BOT['EN']					= "\n# All good, so return
\$IPT -A bad_neighbours -p ALL -j RETURN

###############################################################################
#
# INPUT Chain
#

echo 'Process INPUT chain ...'

# Allow all on localhost interface
\$IPT -A INPUT -p ALL -i \$LO_IFACE -j ACCEPT

# Drop bad packets
\$IPT -A INPUT -p ALL -j bad_packets

# DOCSIS compliant cable modems
# Drop them without logging.
\$IPT -A INPUT -p ALL -d 224.0.0.1 -j DROP
# The rule to accept the packets.
# \$IPT -A INPUT -p ALL -d 224.0.0.1 -j ACCEPT


# Inbound Internet Packet Rules

# Accept Established Connections
\$IPT -A INPUT -p ALL -i \$INET_IFACE -m state --state ESTABLISHED,RELATED \
     -j ACCEPT

# $NOW DROP bad neighbourhoods
\$IPT -A INPUT -p ALL -j bad_neighbours

# Route the rest to the appropriate user chain\n";

	$HTA_TOP['EN']					= "\n# Blacklisting
# BE MOST CAREFUL! Can deny yourself, important IPs, or everyone
# See http://httpd.apache.org/docs/2.2/mod/mod_authz_host.html
#
# $NOW updated
# Deny listing from The Aggregator
# ${_SERVER['SCRIPT_URI']}
Order allow,deny
Allow from all\n";

	$HTA_BOT['EN']					= "\n
Above to be used within a .htaccess file

For further information, see:

(url to be added)\n";

	$ZBB_BOT['EN']					= "\n$NOW
Above to be used within ZB-Block signatures.

For further information, see:

http://www.spambotsecurity.com/zbblock.php\n";

	$BAD_TPL['EN']					= "\$IPT -A bad_neighbours -p ALL -s 123456789abcdef012 -j DROP\n";

	$ZBB_TPL['EN']					= "\$ax += cidrblock(\$address,'DATA','cidr-block-reason (cidr-code-###). ');\n";
// vi: shiftwidth=3 tabstop=3 et
?>