<?php
/* aggregate.php
 *    PHP www script utility to aggregate prefixes from ASN
 *
 * 2015-03-27 v2.0.3b removed unnecessary mysql_close()
 * 2015-03-25 v2.0.3  added version display
 * 2015-03-24 v2.0.2  added extra lang (DA, DE + NL)
 * 2015-03-22 v2.0.1  added language feature (EN, ES + FR to start)
 * 2015-03-18 v2.0.0  dir + filename, etc. changes for GPL
 *                    MH-specific features stripped
 *                    moved to html5 + utf8 display
 * 2014-02-10 v1.0.4  added HTA (.htaccess) output option
 * 2013-02-15 v1.0.3  activated ASN using cURL routines
 * 2013-02-12 v1.0.2  added ZB-Block signature generation + ipincidr()
 * 2012-10-30 v1.0.1  improved entry reporting (mask, ranges previously reported as cidr)
 *                   +bugfix on Range reporting (explicit section for Ranges added)
 * 2012-04-21 v1.0.0  Started -AK
 *
 * TAB=3
 *
 * @category Net
 * @version $Id: aggregate.php, v2.0.1 2015-03-22
 * @author Alex KEMP
 */
 	error_reporting( E_ALL );
	ini_set('error_log', 'syslog');					// send errors to the system log
	ob_start();												// required for Conteg
	require_once('/home/htdocs/hosted/modem-help.co.uk/www/aggregator/config.inc');
						// changeme! (make sure is in include path or specify fully)
	require_once( AGG_CONTEG );
	require_once( AGG_TEMPLATE );

// -------------- Start of Security Section ---------------
	if( $_REQUEST ) {
		while( list( $k, $v ) = each( $_REQUEST )) {
			if( is_array( $_REQUEST[ $k ])) {
				foreach( $_REQUEST[ $k ] as $aK => $aV ) {
					$_REQUEST[ $k ][ $aK ] = strTransform( trim( $aV ));
				}
			} else $_REQUEST[ $k ] = strTransform( trim( $v ));
		}
	}

	// non-language-dependent variables
	$LANG			= ( isset( $_POST['lang']))	? strtoupper( substr( $_POST['lang'], 0, 2 ))	: '';
	$ASN			= ( isset( $_POST['asn']))
		? (( strtolower( substr( $_POST['asn'], 0, 2 )) == 'as')
			? (int) substr( $_POST['asn'], 2 )
			: (int) $_POST['asn']
		)
		: '';
	$TXT			= ( isset( $_POST['txt']))		? (string) $_POST['txt']		: '';

	$OUTPUT		= ( isset( $_POST['output']))	? (string) $_POST['output']	: '';
	$L_CIDR		= // deliberately left empty!
	$L_MASK		= // deliberately left empty!
	$L_RANGE		= // deliberately left empty!
	$L_ZBB		= // deliberately left empty!
	$L_HTA		= // deliberately left empty!
	$L_BAD		= '';
	$tmp			= 'checked="checked"';
	switch( $OUTPUT ) {
		case 'MASK':	$L_MASK	= $tmp;	break;
		case 'Range':	$L_RANGE	= $tmp;	break;
		case 'Bad':		$L_BAD	= $tmp;	break;
		case 'ZBB':		$L_ZBB	= $tmp;	break;
		case 'HTA':		$L_HTA	= $tmp;	break;
		case 'CIDR':
		default:			$L_CIDR	= $tmp;	break;
	}
// -------------- End   of Security Section ---------------
// -------------- Start of Language Section ---------------
	// init lang arrays for template
	$S_CONTENT_DIRECTION			= array();

	$ENTRY_TIP						= array();
	$ERROR_TEXT_ASN				= array();
	$ERROR_TEXT_EMPTY				= array();
	$ERROR_TEXT_SIZE				= array();
	$ERRTXT_200_01					= array();
	$ERRTXT_200_02					= array();
	$ERRTXT_200_03					= array();
	$ERRTXT_200_04					= array();
	$ERRTXT_200_05					= array();
	$ERRTXT_200_06					= array();
	$ERRTXT_200_07					= array();
	$ERRTXT_200_08					= array();
	$ERRTXT_200_09					= array();
	$ERRTXT_200_10					= array();
	$ERRTXT_200_11					= array();
	$ERRTXT_200_12					= array();
	$ERRTXT_200_13					= array();
	$ERRTXT_200_14					= array();
	$ERRTXT_200_15					= array();
	$ERRTXT_200_16					= array();
	$ERRTXT_200_17					= array();
	$ERRTXT_200_18					= array();
	$ERRTXT_400_1					= array();
	$ERRTXT_400_2					= array();
	$ERRTXT_403_1					= array();
	$L_BAD_KEY						= array();
	$L_BAD_TEXT						= array();
	$L_BAD_TITLE					= array();
	$L_CIDR_KEY						= array();
	$L_CIDR_TEXT					= array();
	$L_CIDR_TITLE					= array();
	$L_HTA_KEY						= array();
	$L_HTA_TEXT						= array();
	$L_HTA_TITLE					= array();
	$L_MASK_KEY						= array();
	$L_MASK_TEXT					= array();
	$L_MASK_TITLE					= array();
	$L_OUTPUT_ASN					= array();
	$L_OUTPUT_OUTPUT				= array();
	$L_OUTPUT_TEXT					= array();
	$L_POST							= array();
	$L_RANGE_KEY					= array();
	$L_RANGE_TEXT					= array();
	$L_RANGE_TITLE					= array();
	$L_RESULT						= array();
	$L_ZBB_KEY						= array();
	$L_ZBB_TEXT						= array();
	$L_ZBB_TITLE					= array();
	$PAGE_TITLE						= array();
	$SUBMIT							= array();

	// following used on no-post pages
	$BAD_BOT							= array();
	$BAD_TOP							= array();
	$BAD_TPL							= array();
	$HTA_BOT							= array();
	$HTA_TOP							= array();
	$RESULTS							= array();
	$ZBB_BOT							= array();
	$ZBB_TPL							= array();
// -------------- End   of Language Section ---------------
// -------------- Start of Common-top Section -------------
	$_Encode							= new Conteg( array(
		'cpu_number'			=> CFG_CPU_NUM,	// number of CPU in server
		'noprint'				=> TRUE,				// display page only on explicit show()
		'use_etag'				=> TRUE,
		'use_accept_lang'		=> TRUE,				// vary by language
		'use_apache_notes'	=> TRUE,				// pass compression stats to Apache logs
	));
	$BITS				= array();	// aggregated CIDRs: prefix, int
	$cidrs			= array();	// unsorted result from entry (possibly not CIDRs!)
	$CIDRS			= array();	// aggregated CIDRs
	$CIDRS_BAD		= array();	// bad CIDRs as array
	$CIDR_BAD		= '';			// rejected CIDRs
	$CIDR_REPORT	= 'http://www.cidr-report.org/cgi-bin/as-report?as=ASXXXXX&view=2.0';
	$Display			= '';
	$ENDS				= array();	// used for aggregation
	$HI				= array();	// aggregated CIDRs: broadcast address, int
	$LO				= array();	// aggregated CIDRs: network address, int
	$MESSAGE			= '';			// show entry CIDRs, etc.
	$MODIFIED		= strtotime('2015-03-27 11:56');
	$NETS				= array();	// used for aggregation
	$NETWORKS		= array();	// used for aggregation
	$NOW				= date('Y-m-d');
	$num_size		= 0;			// for RESULTS
	$num_results	= 0;			// for RESULTS
	$POST_LIMIT		= 131072;	// 128k of text
	$NO_POST			= ( empty( $_POST ))	? TRUE	: FALSE;
	$RANGES			= array();	// used for aggregation
	$SUBJECT			= '';
//	$SUBJECT			= 'ASN entry disabled';
	$SUPPLIED_CIDR	= 0;			// for RESULTS
	$SUPPLIED_MASK	= 0;			// for RESULTS
	$SUPPLIED_RANG	= 0;			// for RESULTS
	$SUPPLIED_TOTL	= 0;			// for RESULTS
	$Template		= new Template( CFG_INC_DIR );
	$template		= 'viewagg_body.tpl';
	$TYPES			= array();	// used for aggregation
	$VERSION			= 'v2.0.3a';
	$YEAR_NOW		= date('Y');
	$url				= '';

	$_LANG			= 'EN';	// default
	// next section so no need to import 100+ include files!
	// my wretched Windows-based editor keeps switching back to ANSI
	// the foll therefore a Horrible Hack (TM) (also cannot use html entities)
	// for code-points: http://www.utf8-chartable.de/
	$c					= "\xC3\xA7";
	$n					= "\xC3\xB1";
	$OPTIONS			= array(
							'DA' => 'DA Dansk',
							'DE' => 'DE Deutsch',
							'EN' => 'EN English',
							'ES' => "ES Espa{$n}ol",
							'FR' => "FR Fran{$c}ais",
							'NL' => "NL Nederlandse",
						);

	// lang processing
	if( !empty( $LANG )) {
		// is POST + specific language requested
		$tmp		= CFG_LANG_DIR ."$LANG/agg.inc";
		if(( isset( $OPTIONS[ $LANG ])) and ( file_exists( $tmp ))) {
			$_LANG	= $LANG;
		}
	} else {
		if( $NO_POST ) {
			// try to find user default language
			$tmp		= $_Encode->getAcceptLang();
			$con		= TRUE;
			// find most acceptable lang; array is in order of preference, high to low
			foreach( $tmp as $lang => $i ) {
				// perversely, lang is the key & order is the value
				// (done that way so arsort will work)
				if( $con ) {
					if( $lang == '*') {	// any lang is acceptable
						// use lang default ($_LANG)
						$con		= FALSE;
					} else {
						$lang	= strtoupper( substr( $lang, 0, 2 ));
						if(( isset( $OPTIONS[ $lang ])) and ( file_exists( CFG_LANG_DIR ."/$lang/agg.inc"))) {
							$_LANG	= $lang;
							$con		= FALSE;
						}
					}
				}
			}
		} // if( $NO_POST )
	}	// if( !empty( $LANG )) else

	$LANG_OPTIONS					= '';
	foreach( $OPTIONS as $key => $val ) {
		$LANG_OPTIONS	.= "<option value='$key'".
			(($_LANG == $key ) ? " selected='selected'" : '').
			">$val</option>\n";
	}

	$tmp								= CFG_LANG_DIR ."/$_LANG/agg.inc";
	// IMPORTANT NOTE: embedded php in $tmp uses variable values current
	//                 at this moment of imclusion.
	require_once( $tmp );

	// one template for all pages
	$Template->set_filenames( array('body' => $template ));
// -------------- End   of Common-top Section -------------
// -------------- Start of Functions Section --------------
// ip2num()
//
// convert string IPv4 (0.0.0.0) to unsigned numeric
	function ip2num(
		$ip		// string
	) {
		// sanity checks
		$long							= ip2long( $ip );
		if(( $long == -1 ) or ( $long === FALSE ))	return FALSE;
		$ip							= long2ip( $long );

		// convert to unsigned numeric
		list( $a, $b, $c, $d )	= explode('.', $ip );
		return ( $a << 24 ) + ( $b << 16 ) + ( $c << 8 ) + $d;
	}	// function ip2num
// ipincidr() - not used in this script
// return whether given IP is part of given CIDR
//
// return:
// 0     = ip NOT in cidr
// 1     = ip IS in cidr
// FALSE = error in supplied credentials
	function ipincidr(
		$ip,			// string (0.0.0.0) or numeric
		$cidr			// correctly formatted `a.b.c.d/bits' address
	) {
		if( is_string( $ip )) {
			// sanity checks + convert to unsigned numeric
			if(( $ip = ip2num( $ip )) === FALSE )	return FALSE;
		}

		if(( $ips = ipv4( $cidr )) === FALSE )	return FALSE;

		if( $ip < $ips['lo'])		return 0;
		elseif( $ip > $ips['hi'])	return 0;
		else								return 1;
	}	// function ipincidr
// ipv4()
// return array with network + broadcast ip for a CIDR
	function ipv4(
		$cidr		// requires a correctly formatted `a.b.c.d/bits' address
	) {
		$ips							= array();

		list( $ip, $bits )		= explode('/', $cidr );

		// sanity checks
		if(( $bits < 1 ) or ( $bits > 32 ))		return FALSE;
		if(( $ip = ip2num( $ip )) === FALSE )	return FALSE;

		$mask							= ( $bits == 0 )
			? 0
			: ( 0xFFFFFFFF << ( 32 - $bits ));

		// prefix
		$ips['bits']				= $bits;
		$ips['mask']				= $mask;

		// lowest IP (network address if /30 or bigger)
		$ips['lo']					= $ip & $mask;

		// highest IP (broadcast address if /30 or bigger)
		$ips['hi']					= $ip | ( ~$mask & 0xFFFFFFFF );

		return $ips;
	}	// function ipv4
// mask2cidr()
// convert a net-mask to a CIDR prefix
//
// ($mask ^ 0xFFFFFFFF) gives the inverse mask
// log base 2 of that + 1 gives number of bits off in the mask
// subtracting from 32 gives the CIDR prefix
	function mask2cidr(
		$mask		// string (0.0.0.0) or numeric
	) {
		if( is_string( $mask )) {
			// sanity checks + convert to unsigned numeric
			if(( $mask = ip2num( $mask )) === FALSE )	return FALSE;
		}

		return 32 - log(( $mask ^ 0xFFFFFFFF ) + 1, 2 );

/*		// alternative 1: use a lookup table
		// see http://graphics.stanford.edu/~seander/bithacks.html#CountBitsSetTable
		static $BitsSetTable256	= array(
			0, 1, 1, 2,  1, 2, 2, 3,  1, 2, 2, 3,  2, 3, 3, 4,
			1, 2, 2, 3,  2, 3, 3, 4,  2, 3, 3, 4,  3, 4, 4, 5,
			1, 2, 2, 3,  2, 3, 3, 4,  2, 3, 3, 4,  3, 4, 4, 5,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			1, 2, 2, 3,  2, 3, 3, 4,  2, 3, 3, 4,  3, 4, 4, 5,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			3, 4, 4, 5,  4, 5, 5, 6,  4, 5, 5, 6,  5, 6, 6, 7,
			1, 2, 2, 3,  2, 3, 3, 4,  2, 3, 3, 4,  3, 4, 4, 5,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			3, 4, 4, 5,  4, 5, 5, 6,  4, 5, 5, 6,  5, 6, 6, 7,
			2, 3, 3, 4,  3, 4, 4, 5,  3, 4, 4, 5,  4, 5, 5, 6,
			3, 4, 4, 5,  4, 5, 5, 6,  4, 5, 5, 6,  5, 6, 6, 7,
			3, 4, 4, 5,  4, 5, 5, 6,  4, 5, 5, 6,  5, 6, 6, 7,
			4, 5, 5, 6,  5, 6, 6, 7,  5, 6, 6, 7,  6, 7, 7, 8
		);

		// algorithmically
//		if( empty( $BitsSetTable256 )) {
//			$BitsSetTable256[ 0 ]	= 0;
//			for( $i = 0; $i < 256; $i++ ) {
//				$BitsSetTable256[ $i ]	= ( $i & 1 ) + $BitsSetTable256[ $i >> 1 ];
//			}
//		}

		if( is_string( $mask )) {
			// sanity checks + convert to unsigned numeric
			if(( $mask = ip2num( $mask )) === FALSE )	return FALSE;
		}

		return
			$BitsSetTable256[ $mask & 0xff] +
			$BitsSetTable256[( $mask >> 8 ) & 0xff ] +
			$BitsSetTable256[( $mask >> 16) & 0xff ] +
			$BitsSetTable256[ $mask >> 24 ];

		// alternative 2: Brian Kernighan's method
		// see http://graphics.stanford.edu/~seander/bithacks.html#CountBitsSetKernighan
		for( $bits = 0; $mask; $bits++ ) {
		  $mask &= $mask - 1; // clear the least significant bit set
		}

		return $bits;
*/	}	// function mask2cidr
// range2cidr()
//
// convert an IP range into an array of CIDRs
// see http://snipplr.com/view/15557/cidr-class-for-ipv4/
// eg:
// 127.0.0.1 - 127.0.0.34
// =>
// 127.0.0.1/32
// 127.0.0.2/31
// 127.0.0.4/30
// 127.0.0.8/29
// 127.0.0.16/28
// 127.0.0.32/31
// 127.0.0.34/32
	function range2cidr(
		$startIP,
		$endIP
	) {
		$cidrs	= array();
		if( is_string( $startIP )) {
			// sanity checks + convert to unsigned numeric
			if(( $startIP = ip2num( $startIP )) === FALSE )	return FALSE;
		}
		if( is_string( $endIP )) {
			// sanity checks + convert to unsigned numeric
			if(( $endIP = ip2num( $endIP )) === FALSE )		return FALSE;
		}

		while( $endIP >= $startIP ) {
			// net2mask: two's complement of (net AND (two's complement of net))
			// `& 0xFFFFFFFF' keeps at 32-bit on 64-bit machines
			$maxsize	= mask2cidr(( -( $startIP & ( -$startIP ))) & 0xFFFFFFFF );	// max cidr this ip could fit into
			$maxdiff	= 32 - intval( log( $endIP - $startIP + 1 ) / log( 2 ));
			$size		= ( $maxsize > $maxdiff )
				? $maxsize
				: $maxdiff;
			$cidrs[]	= long2ip( $startIP ) ."/$size";
			$startIP	+= pow( 2, ( 32 - $size ));
		}

		return $cidrs;
	}	// function range2cidr
// -------------- End   of Functions Section --------------
// -------------- Start of Display Section ----------------
	if( empty( $TXT ) and empty( $ASN )) {
// Start of No-Content-Needed Check
		// browsers do not send If-Modified, etc. on POST
		// important that below exactly matches setup at end of script
		$conteg_param		= array(
			'charset'	=> $S_CONTENT_ENCODING,
			'modified'	=> $MODIFIED,
			'lang'		=> $_LANG
		);
		$_Encode->setup( $conteg_param );
		if( $_Encode->isResponseNoContent()) {
			// 304, 406 or 412
			$_Encode->show();
			mysql_close();
			exit();
		}
// End of No-Content-Needed Check
	} else {	// if( empty( $TXT ) and empty( $ASN ))
		$tmp		= '[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}';
		$pattern	= "#($tmp\s*-\s*$tmp)|($tmp/$tmp)|($tmp(/[0-9]{1,2}){0,1})#m";
		$matches	= array();
		// after preg: $matches[0][0] => 192.168.37.215
		//             $matches[0][1] => 192.168.37.215/27
		//             $matches[0][2] => 192.168.37.215/255.255.255.224
		//             $matches[0][3] => 192.168.37.192 - 192.168.37.223
		//             $matches[1][0] =>
		//             $matches[1][1] =>
		//             $matches[1][2] =>
		//             $matches[1][3] => 192.168.37.192 - 192.168.37.223
		//             $matches[2][0] =>
		//             $matches[2][1] =>
		//             $matches[2][2] => 192.168.37.215/255.255.255.224
		//             $matches[2][3] =>
		// ...
		//             $matches[4][0] =>
		//             $matches[4][1] => /27
		//             $matches[4][2] =>
		//             $matches[4][3] =>

		if( $ASN ) {
			$url	= str_replace('XXXXX', $ASN, $CIDR_REPORT );

			if(( $TXT = @agg_get( $url )) == FALSE ) {
				$RESULTS[ $_LANG ]	= str_replace('_URL', $url, $ERROR_TEXT_ASN[ $_LANG ]);

				if( !( $Display = @include( CFG_LANG_DIR ."$_lang/show_400_agg.inc"))) {
					if( !headers_sent()) {
						header('HTTP/1.0 400: Bad Request');
					}
					trigger_error( str_replace('xxx', $url, $ERRTXT_400_1[ $_LANG ]), E_USER_ERROR );
					exit;
				}
				$conteg_param	= array(
					'cache_control'	=> array('macro' => 'cache-none'),
					'http_status'		=> '400'
				);
				echo $Display;	// error msg
				$_Encode->setup( $conteg_param );
				$_Encode->show();
				exit;
			} else {
				$num_size	= strlen( $TXT );
			}
		} else if(( $num_size = strlen( $TXT )) > $POST_LIMIT ) {
			$RESULTS[ $_LANG ]	= str_replace('xxx', number_format( $num_size ), $ERROR_TEXT_SIZE[ $_LANG ]);

			if( !( $Display = @include( CFG_LANG_DIR ."$_lang/show_403_agg.inc"))) {
				if( !headers_sent()) {
					header('HTTP/1.0 403: Forbidden');
				}
				trigger_error( str_replace('xxx', $num_size, $ERRTXT_403_1[ $_LANG ]), E_USER_ERROR );
				exit;
			}
			$conteg_param	= array(
				'cache_control'	=> array('macro' => 'cache-none'),
				'http_status'		=> '403'
			);
			echo $Display;	// error msg
			$_Encode->setup( $conteg_param );
			$_Encode->show();
			exit;
		}

		preg_match_all( $pattern, $TXT, $matches );
		if( empty( $matches )) {
			$RESULTS[ $_LANG ]	= $ERROR_TEXT_EMPTY[ $_LANG ];

			if( !( $Display = @include( CFG_LANG_DIR ."$_lang/show_400_agg.inc"))) {
				if( !headers_sent()) {
					header('HTTP/1.0 400: Bad Request');
				}
				trigger_error( $ERRTXT_400_2[ $_LANG ], E_USER_ERROR );
				exit;
			}
			$conteg_param	= array(
				'cache_control'	=> array('macro' => 'cache-none'),
				'http_status'		=> '400'
			);
			echo $Display;	// error msg
			$_Encode->setup( $conteg_param );
			$_Encode->show();
			exit;
		}

		$tmp				= array();
		foreach( $matches[ 0 ] as $i => $cidr ) {
			if( !empty( $matches[ 1 ][ $i ])) {
				// it is an IP Range
				$arr		= array();
				$pos		= strpos( $cidr, '-');
				$ip1		= trim( substr( $cidr, 0, $pos ));
				$ip2		= trim( substr( $cidr, $pos + 1 ));
				if(( $arr = range2cidr( $ip1, $ip2 )) === FALSE ) {
					$CIDRS_BAD[]	= str_replace('xxx', $cidr, $ERRTXT_200_01[ $_LANG ]);
					continue;
				} else {
					foreach( $arr as $CIDR ) {
						$tmp[]	= $CIDR;
					}
					$MESSAGE			.= "{$matches[1][$i]}\n";
					$SUPPLIED_RANG	+= 1;
				}
			} elseif( !empty( $matches[ 2 ][ $i ])) {
				// it is an IP/Mask
				$pos		= strpos( $cidr, '/');
				$ip		= trim( substr( $cidr, 0, $pos ));
				$mask		= trim( substr( $cidr, $pos + 1 ));
				// mask == 255.255.255.255 will throw an error
				// therefore we fudge it
				if( $mask == '255.255.255.255') {
					$tmp[]			= "$ip/32";
					$MESSAGE			.= "{$matches[2][$i]}\n";
					$SUPPLIED_MASK	+= 1;
				} elseif(( $bits = mask2cidr( $mask )) === FALSE ) {
					$CIDRS_BAD[]	= str_replace('xxx', $cidr, $ERRTXT_200_02[ $_LANG ]);
					continue;
				} else {
					$tmp[]			= "$ip/$bits";
					$MESSAGE			.= "{$matches[2][$i]}\n";
					$SUPPLIED_MASK	+= 1;
				}
			} else {
				// bare IP (TRUE) or IP/Prefix
				// account for `0.0.0.0' + `0.0.0.0/0' entries
				if(( $cidr == '0.0.0.0') or ( $cidr == '0.0.0.0/0')) {
					$CIDRS_BAD[]	.= str_replace('xxx', $cidr, $ERRTXT_200_03[ $_LANG ]);
					continue;
				}

				$tmp[]	= ( empty( $matches[ 4 ][ $i ]))
					? "$cidr/32"
					: $cidr;
				$MESSAGE			.= "$cidr\n";
				$SUPPLIED_CIDR	+= 1;
			}
		}	// foreach( $matches[ 0 ] as $i => $cidr )
		$SUPPLIED_TOTL	= $SUPPLIED_RANG + $SUPPLIED_MASK + $SUPPLIED_CIDR;

		// remove dupes (faster than array_unique())
		$cidrs	= array_keys( array_flip( $tmp ));
		unset( $matches, $tmp, $TXT );

		// now aggregate all the CIDRs
		// $CIDRs: addresses are stored as int
		//   $LO[ network ]     = network address (also lowest IP), int
		//   $HI[ network ]     = broadcast address (also highest IP), int
		$store	= TRUE;	// to solve the 'cannot break twice' quandry
		foreach( $cidrs as $cidr ) {
			if(( $ips = ipv4( $cidr )) != FALSE ) {
				foreach( $LO as $network ) {
					// check for existing identical / broader range
					if(
						( $ips['lo'] >= $network ) and
						( $ips['hi'] <= $HI[$network])
					) {
						$store	= FALSE;	// do not want to store this smaller range
						break;				// as will overwrite larger with same network ip
					}
				}
				if( $store ) {
					// supplied IP/Prefix does not fit within any ranges so far collected
					// so store this CIDR
					$LO[ $ips['lo']]		= $ips['lo'];
					$HI[ $ips['lo']]		= $ips['hi'];
					$ENDS[]					= $ips['lo'];
					$TYPES[]					= 'lo';
					$NETWORKS[]				= $ips['lo'];
					$ENDS[]					= $ips['hi'];
					$TYPES[]					= 'hi';
					$NETWORKS[]				= $ips['lo'];
				} else {
					$store					= TRUE;
				}
			} else {
				$CIDRS_BAD[]	.= "$cidr\n";
			}	// if(( $ips = ipv4( $cidr )) != FALSE ) else
		}	// foreach( $cidrs as $cidr )

		// remove $CIDRS_BAD dupes (faster than array_unique())
		$CIDR_BAD	= implode("\n", array_keys( array_flip( $CIDRS_BAD )));

		// now consolidate overlapping/embedded and/or contiguous ranges
		// this uses a `a union of segments computation' algorithm found here:
		// http://stackoverflow.com/questions/149577/
		// /need-an-algorithm-for-collapsing-netblock-ranges-into-lists-of-superset-ranges
		//
		// first sort the end-points
		array_multisort( $ENDS, SORT_ASC, SORT_NUMERIC,
								$TYPES, SORT_DESC, SORT_STRING,
								$NETWORKS, SORT_ASC, SORT_NUMERIC
		);

		// walk the arrays
		// when ($lo - $hi == 0) we have reached the end of a connected union of segments
		// all networks within that span are part of the same superset
		$lo	= 0;		// number of 'lo' endpoints passed
		$hi	= 0;		// number of 'hi' endpoints passed
		$nw	= 0;		// network IP for the current superset
		foreach( $ENDS as $i => $endpoint ) {
			if(( $lo == 0 ) and ( $hi == 0 )) {
				// start of a new superset
				$network								= $NETWORKS[ $i ];
				$nw									= // deliberately left empty!
				$NETS[]								= // deliberately left empty!
				$RANGES[ $network ]['lo']		= $network;
			}

			$type		= $TYPES[ $i ];
			if( $type == 'lo')	$lo++;
			if( $type == 'hi')	$hi++;

			if(( $lo - $hi ) == 0 ) {
				// end of the current superset
				$RANGES[ $nw ]['hi']				= $HI[ $nw ];
				$lo									= // deliberately left empty!
				$hi									= 0;
			}
		}

		unset( $cidrs, $LO, $HI, $ENDS, $TYPES, $NETWORKS );

		// account for any contiguous ranges
		foreach( $NETS as $i => $network ) {
			if(
				( !empty( $NETS[ $i + 1 ])) and
				( $RANGES[ $network ]['hi'] == ( $RANGES[ $NETS[ $i + 1 ]]['lo'] - 1 ))
			) {
				// 2 contiguous networks; let's consolidate them
				$RANGES[ $NETS[ $i + 1 ]]['lo']		= $RANGES[ $network ]['lo'];
				unset( $RANGES[ $network ]);
			}
		}
		unset( $NETS );

		// almost there...
		if( $OUTPUT != 'Range') {
			// finally, parse RANGES into network-legal CIDRS
			// note: due to the NETS foreach, RANGES base-index may no longer == 'lo'
			foreach( $RANGES as $i => $range ) {
				$cidrs	= range2cidr( $range['lo'], $range['hi']);
				foreach( $cidrs as $cidr ) {
					$CIDRS[] = ipv4( $cidr );
				}
			}
		}
		switch( $OUTPUT ) {
			case 'MASK':	$tmp	= $ERRTXT_200_04[ $_LANG ];	break;
			case 'Range':	$tmp	= $ERRTXT_200_05[ $_LANG ];	break;
			case 'Bad':		$tmp	= $ERRTXT_200_06[ $_LANG ];	break;
			case 'ZBB':		$tmp	= $ERRTXT_200_07[ $_LANG ];	break;
			case 'HTA':		$tmp	= $ERRTXT_200_08[ $_LANG ];	break;
			case 'CIDR':
			default:			$tmp	= $ERRTXT_200_09[ $_LANG ];	break;
		}

		$num_results			= ( $OUTPUT != 'Range')
			? count( $CIDRS )
			: count( $RANGES );
		$num_size				= ( $num_size < 1024 ) ? '< 1' : number_format( $num_size / 1024 );
		$RESULTS[ $_LANG ]	= number_format( $SUPPLIED_RANG ) . $ERRTXT_200_10[ $_LANG ] .
								number_format( $SUPPLIED_MASK ) . $ERRTXT_200_11[ $_LANG ] .
								number_format( $SUPPLIED_CIDR ) . $ERRTXT_200_12[ $_LANG ] .
								number_format( $num_results ) . str_replace('xxx', $tmp, $ERRTXT_200_13[ $_LANG ]);
		if( $OUTPUT == 'Bad')	$RESULTS[ $_LANG ]	.= $BAD_TOP[ $_LANG ];
		if( $OUTPUT == 'HTA')	$RESULTS[ $_LANG ]	.= $HTA_TOP[ $_LANG ];

		// now--hoorah!--we can print out the results
		if( $OUTPUT != 'Range') {
			foreach( $CIDRS as $i => $arr ) {
				switch( $OUTPUT ) {
					case 'MASK':	$RESULTS[ $_LANG ]	.= long2ip( $arr['lo']) .'/'. long2ip( $arr['mask']) ."\n";	break;
					case 'Bad':		$cidr						= long2ip( $arr['lo']) ."/{$arr['bits']}";
										$RESULTS[ $_LANG ]	.= str_replace('123456789abcdef012', str_pad( $cidr, 18 ), $BAD_TPL[ $_LANG ]);
																																	break;
					case 'ZBB':		$cidr						= long2ip( $arr['lo']) ."/{$arr['bits']}";
										$zbb						= str_replace('DATA', $cidr, $ZBB_TPL[ $_LANG ]);
										$zbb						= str_replace('###', $i, $zbb );
										$RESULTS[ $_LANG ]	.= $zbb;
																																	break;
					case 'HTA':		$RESULTS[ $_LANG ]	.= 'Deny from '. long2ip( $arr['lo']) ."/{$arr['bits']}\n";	break;
					case 'CIDR':
					default:			$RESULTS[ $_LANG ]	.= long2ip( $arr['lo']) ."/{$arr['bits']}\n";					break;
				}
			}
			if( $OUTPUT == 'Bad')	$RESULTS[ $_LANG ]	.= $BAD_BOT[ $_LANG ];
			if( $OUTPUT == 'ZBB')	$RESULTS[ $_LANG ]	.= $ZBB_BOT[ $_LANG ];
		} else {
			foreach( $RANGES as $arr ) {
				$RESULTS[ $_LANG ]	.= long2ip( $arr['lo']) .' - '. long2ip( $arr['hi']) ."\n";
			}
		}	// if( $OUTPUT != 'Range') else

		// show IPs considered/rejected in entry text
		$MESSAGE			= $ERRTXT_200_14[ $_LANG ].
			(( empty( $ASN ))
				? ''
				: str_replace('xxx', $url, $ERRTXT_200_15[ $_LANG ])
			).
			str_replace( array('xxx','XXX'), array( $tmp,$num_size ), $ERRTXT_200_16[ $_LANG ]).
			substr_count( $CIDR_BAD, "\n") .$ERRTXT_200_17[ $_LANG ].
			(( empty( $CIDR_BAD ))
				? ''
				: $CIDR_BAD
			) ."\n".
			number_format( $SUPPLIED_TOTL ) . str_replace('xxx', $MESSAGE, $ERRTXT_200_18[ $_LANG ]);
	}	// if( empty( $TXT ) and empty( $ASN )) else

		$FORM_FIELDS	= '';
		$HOME				= U_INDEX .'aggregate.php';
		$META				= '';
		$NAV_LINKS		= '';
		$POST_ACTION	= $HOME;
		$TOPIC_TITLE	= $PAGE_TITLE[ $_LANG ];
		$VIEW_NAV		= " &raquo; <a href='$HOME' class='nav'>${PAGE_TITLE[ $_LANG ]}</a>";
		$VIEW_TOPIC		= '';

		$Template->assign_vars( array(
			'A_INDEX'					=> A_INDEX,
			'L_BAD'						=> $L_BAD,
			'L_BAD_KEY'					=> $L_BAD_KEY[ $_LANG ],
			'L_BAD_TEXT'				=> $L_BAD_TEXT[ $_LANG ],
			'L_BAD_TITLE'				=> $L_BAD_TITLE[ $_LANG ],
			'L_CIDR'						=> $L_CIDR,
			'L_CIDR_KEY'				=> $L_CIDR_KEY[ $_LANG ],
			'L_CIDR_TEXT'				=> $L_CIDR_TEXT[ $_LANG ],
			'L_CIDR_TITLE'				=> $L_CIDR_TITLE[ $_LANG ],
			'L_ENTRY_TIP'				=> $ENTRY_TIP[ $_LANG ],
			'L_HTA'						=> $L_HTA,
			'L_HTA_KEY'					=> $L_HTA_KEY[ $_LANG ],
			'L_HTA_TEXT'				=> $L_HTA_TEXT[ $_LANG ],
			'L_HTA_TITLE'				=> $L_HTA_TITLE[ $_LANG ],
			'L_INDEX'					=> L_INDEX,
			'L_MASK'						=> $L_MASK,
			'L_MASK_KEY'				=> $L_MASK_KEY[ $_LANG ],
			'L_MASK_TEXT'				=> $L_MASK_TEXT[ $_LANG ],
			'L_MASK_TITLE'				=> $L_MASK_TITLE[ $_LANG ],
			'L_OUTPUT_ASN'				=> $L_OUTPUT_ASN[ $_LANG ],
			'L_OUTPUT_OUTPUT'			=> $L_OUTPUT_OUTPUT[ $_LANG ],
			'L_OUTPUT_TEXT'			=> $L_OUTPUT_TEXT[ $_LANG ],
			'L_POST'						=> $L_POST[ $_LANG ],
			'L_RANGE'					=> $L_RANGE,
			'L_RANGE_KEY'				=> $L_RANGE_KEY[ $_LANG ],
			'L_RANGE_TEXT'				=> $L_RANGE_TEXT[ $_LANG ],
			'L_RANGE_TITLE'			=> $L_RANGE_TITLE[ $_LANG ],
			'L_RESULT'					=> $L_RESULT[ $_LANG ],
			'L_SUBMIT'					=> $SUBMIT[ $_LANG ],
			'L_VERSION'					=> $VERSION,
			'L_VIEW_NAV'				=> $VIEW_NAV,
			'L_ZBB'						=> $L_ZBB,
			'L_ZBB_KEY'					=> $L_ZBB_KEY[ $_LANG ],
			'L_ZBB_TEXT'				=> $L_ZBB_TEXT[ $_LANG ],
			'L_ZBB_TITLE'				=> $L_ZBB_TITLE[ $_LANG ],
			'LANG_OPTIONS'				=> $LANG_OPTIONS,
			'MESSAGE'					=> $MESSAGE,
			'META'						=> $META,
			'NAV_LINKS'					=> $NAV_LINKS,
			'PAGE_TITLE'				=> $PAGE_TITLE[ $_LANG ],
			'RESULTS'					=> $RESULTS[ $_LANG ],
			'S_CONTENT_DIRECTION'	=> $S_CONTENT_DIRECTION[ $_LANG ],
			'S_CONTENT_ENCODING'		=> $S_CONTENT_ENCODING,
			'S_HIDDEN_FORM_FIELDS'	=> $FORM_FIELDS,
			'S_POST_ACTION'			=> $POST_ACTION,
			'SITENAME'					=> CFG_SITE_NAME,
			'SITE_DESCRIPTION'		=> CFG_SITE_DESC,
			'SUBJECT'					=> $SUBJECT,
			'TOPIC_TITLE'				=> $TOPIC_TITLE,
			'T_BODY_BGCOLOR'			=> T_BODY_BGCOLOR,
			'T_BODY_TEXT'				=> T_BODY_TEXT,
			'T_BODY_LINK'				=> T_BODY_LINK,
			'T_BODY_VLINK'				=> T_BODY_VLINK,
			'U_FAVICON'					=> U_FAVICON,
			'U_INDEX'					=> U_INDEX,
			'U_LOGO'						=> U_LOGO,
			'U_STYLE'					=> U_STYLE,
			'U_VIEW_TOPIC'				=> $VIEW_TOPIC,
			'YEAR_NOW'					=> $YEAR_NOW
		));
		$Template->pparse('body');
// -------------- End   of Display Section ----------------
// -------------- Start of Common-bottom section-----------
	$conteg_param['charset']			= $S_CONTENT_ENCODING;
	$conteg_param['modified']			= $MODIFIED;
	$conteg_param['lang']				= $_LANG;
	$_Encode->setup( $conteg_param );
	$_Encode->show();
// -------------- End of Common-bottom section-------------
// vi: shiftwidth=3 tabstop=3 et
?>